# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   pythonProject
# FileName:      request_methid.py
# Author:       xxxxxxx
# Datetime:     2023/8/5 16:39
# Description:
# 
# ---------------------------------------------------------------------------
import base64

import requests

from interface_bpm.data_extraction.read_ini import ReadIni


class Request:

    def __init__(self):
        domain_name = ReadIni().read_host("test_bpm")
        login_path = domain_name + "/auth"
        login_data = {"username": "admin", "password": "123456"}
        login_data["password"] = base64.b64encode(login_data["password"].encode("utf-8")).decode("utf-8")
        self.req = requests.sessions.Session()
        result = self.req.request(method="post", url=login_path, json=login_data)
        token = result.json()["token"]
        self.req.headers["Authorization"] = "Bearer " + token

    def all_request(self, method, url, mime, data):
        if mime == "application/x-www-form-urlencoded" or mime == "x-www-form-urlencoded":
            return self.req.request(method=method, url=url, data=data)

        elif mime == "application/json" or mime == "json":
            return self.req.request(method=method, url=url, json=data)

        elif mime == "multipart/form-data" or mime == "form-data":
            return self.req.request(method=method, url=url, files=data)

        elif mime == "query" or mime == "params":
            return self.req.request(method=method, url=url, params=data)

        elif mime == "text/plain" or mime == "text":
            return self.req.request(method=method, url=url, data=data)

        elif mime == "application/Json|query" or mime == "json|query" or mime == "json|params":
            return self.req.request(method=method, url=url, params=data["query"], json=data["body"])

        elif mime is None:
            return self.req.request(method=method, url=url)

        else:
            raise AssertionError("输入的媒体类型错误")


if __name__ == '__main__':
    re = Request()
